--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--              SPECIFICATION DU PAQUETAGE NOMBRES_COMPLEXES
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage on definit le type COMPLEXE avec ses operations.     
--                                                                        
--ͼ
with TEXT_IO;
use TEXT_IO;
package NOMBRES_COMPLEXES is

type INDICE is (REEL, IMAGINAIRE);
type COMPLEXE is array(INDICE) of FLOAT;

function "+"(A, B : COMPLEXE) return COMPLEXE;
function "-"(A, B : COMPLEXE) return COMPLEXE;
function "*"(A, B : COMPLEXE) return COMPLEXE;
function "*"(A: FLOAT; B : COMPLEXE) return COMPLEXE;
function "/"(A, B : COMPLEXE) return COMPLEXE;
function MODULE(A : COMPLEXE) return FLOAT;
procedure PUT(z: in COMPLEXE; FORE: in INTEGER := 3; AFT: in INTEGER := 3;
	      EXP: in INTEGER := 0);
procedure PUT(FILE: in FILE_TYPE; z: in COMPLEXE; FORE: in INTEGER := 3; AFT: in INTEGER := 3;
	      EXP: in INTEGER := 0);
end NOMBRES_COMPLEXES;

