--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                SPECIFICATION DU PAQUETAGE COMMON_MATH0   
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des declarations de types et de variables 
-- utilises par MATH0.                                                    
--ͼ

with TEXT_IO;
package COMMON_Math0 is

subtype HEURE is INTEGER range 0..23;
subtype MINUTE is INTEGER range 0..59;
subtype SECONDE is INTEGER range 0..59;
subtype CENTIEME is INTEGER range 0..99;
type TIME is record
	       H: HEURE := 0;
	       M: MINUTE := 0;
	       S: SECONDE := 0;
	       C: CENTIEME := 0;
	     end record;
type PERIPHERIQUE_DE_SORTIE is (ECRAN, IMPRIMANTE, FICHIER);
CHOIX_AFFICHAGE: PERIPHERIQUE_DE_SORTIE := ECRAN;
IMP: TEXT_IO.FILE_TYPE;

end COMMON_MATH0;
