--                  ͻ
--                              J. E. ROMBALDI               
--                       E.N.S.A.M. CHALONS SUR MARNE        
--                            COPYRIGHT (C) 1993             
--                   SPECIFICATION DU PAQUETAGE COMMON_MATH1 
--                  ͼ
-- ͻ
--                          UTILITE DU PAQUETAGE                          
--                                                                        
--  Dans ce paquetage, on trouve des declarations des constantes          
--  mathematiques utilisees dans le paquetage MATH1, ainsi que la         
--  declaration d'une exception qui sera utlisee quand le parametre       
--  fourni ne verifie pas les bonnes conditions (x > 0.0, pour LN(x), ...)
-- ͼ

package COMMON_MATH1 is

PI: constant FLOAT := 3.141_592_653_589_793;
PI_SUR_DEUX: constant FLOAT := 0.5*PI;
PI_SUR_QUATRE: constant FLOAT := 0.25*PI;
DEUX_PI: constant FLOAT := 2.0*PI;
E: constant FLOAT := 2.718_281_828_459_045;

ERREUR_ARGUMENT: exception;

end COMMON_MATH1;
