with TEXT_IO, CRT, MATH0, COMMON_MATH3, MATH3;
use TEXT_IO, CRT, MATH0, COMMON_MATH3, MATH3;

package body CURVE is

procedure CHOIX_AXES(xOrigine , yOrigine , xUnite , yUnite ,
                     xFenMin , xFenMax , yFenMin , yFenMax: out FLOAT) is
begin
    CLRSCR;
    PUT_LINE("Coordonnees de l'origine:");
    ENTRER_REEL(xOrigine,"        Abscisse de l'origine: ");
    ENTRER_REEL(yOrigine,"        Ordonnee de l'origine: ");
    NEW_LINE;
    PUT_LINE("Choix des unites sur les axes:");
    ENTRER_REEL(X_GRD,"        Unite de l'echelle en x: ");
    xUnite := X_GRD;
    ENTRER_REEL(Y_GRD,"        Unite de l'echelle en y: ");
    yUnite := Y_GRD;
    NEW_LINE;
    PUT_LINE("Coordonnees de la fenetre graphique:");
    ENTRER_REEL(xFenMin,"        Abscisse coin inferieur gauche: ");
    ENTRER_REEL(yFenMin,"        Ordonnee coin inferieur gauche: ");
    ENTRER_REEL(xFenMax,"        Abscisse coin superieur droit: ");
    ENTRER_REEL(yFenMax,"        Ordonnee coin superieur droit: ");
end CHOIX_AXES;
-- 
procedure AXES_PAR_DEFAUT(xMin , yMin , xMax , yMax: in FLOAT;
                           xOrigine , yOrigine , xUnite , yUnite ,
			   xFenMin , xFenMax ,
			   yFenMin , yFenMax: in out FLOAT) is
begin
    xOrigine := (xMax + xMin)/2.0;
    yOrigine := (yMin + yMax)/2.0;
    xUnite := (xMax - xMin)/20.0;
    X_GRD := xUnite;
    yUnite := (yMax - yMin)/20.0;
    Y_GRD := yUnite;
    xFenMin := xMin - xUnite;
    xFenMax := xMax + xUnite;
    yFenMin := yMin - yUnite;
    yFenMax := yMax + yUnite;
end AXES_PAR_DEFAUT;
-- 
procedure SYSTEME_AXES(xMin , yMin , xMax , yMax: in FLOAT;
                       xOrigine , yOrigine , xUnite , yUnite ,
		       xFenMin , xFenMax , yFenMin , yFenMax: in out FLOAT) is
CHOIX: INTEGER;
begin
    CLRSCR;
    PUT_LINE(" 1 : Systeme d'axe par defaut.");
    PUT_LINE("     Si les abscisses varient dans l'intervalle [xMin,xMax]");
    PUT_LINE("     et les ordonnees dans [yMin,yMax], on pose alors:");
    PUT_LINE("       Abscisse de l'origine = (xMax + xMin)/2.0;");
    PUT_LINE("       Ordonnee de l'origine = (yMax + yMin)/2.0;");
    PUT_LINE("       Unite sur l'axe des x = (xMax - xMin)/20.0;");
    PUT_LINE("       Unite sur l'axe des y = (yMax - yMin)/20.0;");
    PUT("Abscisse du coin inferieur gauche de la fenetre graphique = ");
    PUT_LINE("xMin - xUnite;");
    PUT("Ordonnee du coin inferieur gauche de la fenetre graphique = ");
    PUT_LINE("yMin - yUnite;");
    PUT("Abscisse du coin superieur droit de la fenetre graphique = ");
    PUT_LINE("xMax + xUnite;");
    PUT("Ordonnee du coin superieur droit de la fenetre graphique = ");
    PUT_LINE("yMax + yUnite .");
    NEW_LINE;
    PUT_LINE(" 2 : Votre systeme d'axes.");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,2,CHOIX,"Votre choix: ");
    CLRSCR;
    if CHOIX = 1 then
      AXES_PAR_DEFAUT(xMin,yMin,xMax,yMax,xOrigine,yOrigine,xUnite,yUnite,
                      xFenMin,xFenMax,yFenMin,yFenMax);
    else
      CHOIX_AXES(xOrigine,yOrigine,xUnite,yUnite,
                 xFenMin,xFenMax,yFenMin,yFenMax);
    end if;
end SYSTEME_AXES;
-- 
procedure INIT_COURBE(C: in out COURBE; xFenMin, xFenMax, yFenMin, yFenMax,
		      xOrigine, yOrigine, xUnite, yUnite: in out FLOAT) is
begin
    C.Rep_Axes := LIRE_REPONSE("Voulez vous le trace des axes? ");
    if C.Rep_Axes then
       NEW_LINE;
       C.Rep_Grille := LIRE_REPONSE("Voulez vous le trace d'une grille? ");
       NEW_LINE;
       SYSTEME_AXES(C.uMin,C.vMin,C.uMax,C.vMax,xOrigine,yOrigine,
                     xUnite,yUnite, xFenMin,xFenMax,yFenMin,yFenMax);
    else
       xUnite := (C.uMax - C.uMin)/20.0;
       yUnite := (C.vMax - C.vMin)/20.0;
       xFenMin := C.uMin - xUnite;
       xFenMax := C.uMax + xUnite;
       yFenMin := C.vMin - yUnite;
       yFenMax := C.vMax + yUnite;
    end if;
end INIT_COURBE;
-- 
procedure TRACE_COURBE(C: in COURBE) is
begin
    TEST_MODE_GRAPHIQUE("TRACE_COURBE");
    DEPLACE(C.u(0),C.v(0));
    for i in C.u'range loop
      TRACE(C.u(i),C.v(i));
    end loop;
end TRACE_COURBE;
-- 
procedure TRACE_UNE_COURBE(C: in out COURBE) is
xOrigine, yOrigine, xUnite, yUnite, xFenMin, xFenMax, yFenMin, yFenMax: FLOAT;
begin
    INIT_COURBE(C,xFenMin,xFenMax,yFenMin,yFenMax,xOrigine,yOrigine,
               xUnite,yUnite);
    INIT_GRAPHIQUE;
    FENETRE_GRAPHIQUE(xFenMin,xFenMax,yFenMin,yFenMax);
    TRACE_COURBE(C);
    if C.Rep_Axes then
        XY_AXES(xOrigine,yOrigine,xUnite,yUnite,C.Rep_Grille);
    end if;
end TRACE_UNE_COURBE;
-- 

end CURVE;

