with TEXT_IO, IIO, CRT, MATH0,
     DEM_PIV, DEM_LR, DEM_GJ, DEM_TRID, DEM_CHOL, DEM_JAC, DEM_REL,
     DEM_VAND, DEM_QR, DEM_DEFL, DEM_RUTI, DEM_SOU, DEM_VPJA;
use TEXT_IO, IIO, CRT, MATH0;

procedure DEM_ALGL is
MAX_CHOIX: constant INTEGER := 13;
subtype CHOIX is INTEGER range 0..MAX_CHOIX;
p: CHOIX;

procedure MENU_ALGEBRE_LINEAIRE(p: out CHOIX) is
begin
    NEW_LINE(5);
    PUT_LINE("    1: Methode des pivots de Gauss");
    PUT_LINE("    2: Methode de Gauss-Jordan");
    PUT_LINE("    3: Decomposition L-R");
    PUT_LINE("    4: Systeme tridiagonal");
    PUT_LINE("    5: Decomposition de Cholesky");
    PUT_LINE("    6: Methode iterative de Jacobi");
    PUT_LINE("    7: Methode iterative de relaxation");
    PUT_LINE("    8: Inversion d'une matrice de Van Der Monde");
    PUT_LINE("    9: Decomposition Q-R");
    PUT_LINE("    10: Recherche de valeurs propres: Methode de deflation");
    PUT_LINE("    11: Recherche de valeurs propres: Methode de Rutishauser");
    PUT_LINE("    12: Recherche de valeurs propres: Methode de Jacobi");
    PUT_LINE("    13: Polynome caracteristique: Methode de Souriau");
    NEW_LINE;
    PUT_LINE("    0: FIN");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,MAX_CHOIX,p,"Votre choix: ");
end MENU_ALGEBRE_LINEAIRE;

begin
    loop
       CLRSCR;
       MENU_ALGEBRE_LINEAIRE(p);
       case p is
	 when 1 => DEM_PIV; PAUSE;
	 when 2 => DEM_GJ; PAUSE;
	 when 3 => DEM_LR; PAUSE;
	 when 4 => DEM_TRID; PAUSE;
	 when 5 => DEM_CHOL; PAUSE;
	 when 6 => DEM_JAC; PAUSE;
	 when 7 => DEM_REL; PAUSE;
	 when 8 => DEM_VAND; PAUSE;
	 when 9 => DEM_QR; PAUSE;
	 when 10 => DEM_DEFL; PAUSE;
	 when 11 => DEM_RUTI; PAUSE;
	 when 12 => DEM_VPJA; PAUSE;
	 when 13 => DEM_SOU; PAUSE;
	 when 0 => exit;
       end case;
    end loop;
end DEM_ALGL;
