with CRT, TEXT_IO, MATH0, MATH3, CURVE, COMMON_MATRIX, DONNEES_POINTS,
     BEZIER;
use CRT, TEXT_IO, MATH0, MATH3, CURVE, COMMON_MATRIX, DONNEES_POINTS,
    BEZIER;

procedure DEM_BEZI is

CHOIX: NATURAL range 0..2;
n, j: NATURAL;

procedure MENU_BEZIER(CHOIX: out NATURAL) is
begin
    CLRSCR;
    PUT_LINE("         COURBES DE BEZIER ");
    NEW_LINE(2);
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Trace des fonctions de base de Bernstein");
    PUT_LINE("-2- Tracer une courbe de Bezier a partir d'un nuage de points");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,CHOIX,"Votre choix: ");
    CLRSCR;
end MENU_BEZIER;
-- 

begin
   loop
      MENU_BEZIER(CHOIX);
      case CHOIX is
	when 0 => exit;
	when 1 =>
	   PUT_LINE("    TRACE DES FONCTIONS DE BASE DE BERNSTEIN");
	   NEW_LINE;
	   ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de fonctions a tracer: ");
	   n := n - 1;
	   TRACE_BASE_BERNSTEIN(n);
	when 2 =>
	      ENTRER_ENTIER_BORNE(3,DIM_MAX,n,
				  "Nombre de points du nuage (> 2): ");
	      n := n - 1;
	      declare
		x, y: VECTEUR(0..n);
		C: COURBE(300);
	      begin
		ENTRER_POINTS(x,y,FALSE);
		PUT_LINE("TRACE DE LA COURBE DE BEZIER");
		COURBE_BEZIER(x, y, C);
		TRACE_UNE_COURBE(C);
		SORTIE_GRAPHIQUE;
	      end;
      end case;
   end loop;
end DEM_BEZI;
