with CRT, TEXT_IO, MATH0, MATH3, CURVE, COMMON_MATRIX, DONNEES_POINTS,
     B_SPLINE;
use CRT, TEXT_IO, MATH0, MATH3, CURVE, COMMON_MATRIX, DONNEES_POINTS,
    B_SPLINE;

procedure DEM_BSPL is

CHOIX: NATURAL range 0..2;
n, j: NATURAL;

procedure MENU_BSPLINE(CHOIX: out NATURAL) is
begin
    CLRSCR;
    PUT_LINE("         COURBES B_SPLINES ");
    NEW_LINE(2);
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Trace des fonctions de base B_Splines");
    PUT_LINE("-2- Tracer une courbe B_Spline a partir d'un nuage de points");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,CHOIX,"Votre choix: ");
    CLRSCR;
end MENU_BSPLINE;
-- 

begin
   loop
      MENU_BSPLINE(CHOIX);
      case CHOIX is
	when 0 => exit;
	when 1 =>
	   PUT_LINE("    TRACE DES FONCTIONS DE BASE B_SPLINE");
	   NEW_LINE;
	   ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de fonctions a tracer: ");
	   n := n - 1;
	   ENTRER_ENTIER_BORNE(2,n + 1,j,"Ordre des B_Splines: ");
	   TRACE_BASE_BSPLINE(n,j);
	when 2 =>
	      ENTRER_ENTIER_BORNE(3,DIM_MAX,n,
				  "Nombre de points du nuage (> 2): ");
	      n := n - 1;
	      ENTRER_ENTIER_BORNE(2,n + 1,j,"Ordre de la B_Spline: ");
	      declare
		x, y: VECTEUR(0..n);
		C: COURBE(300);
	      begin
		ENTRER_POINTS(x,y,FALSE);
		PUT_LINE("TRACE DE LA COURBE D'INTERPOLATION B_SPLINE");
		COURBE_BSPLINE(j, x, y, C);
		TRACE_UNE_COURBE(C);
		SORTIE_GRAPHIQUE;
	      end;
      end case;
   end loop;
end DEM_BSPL;
