with TEXT_IO, FIO, COMMON_MATH0, MATH0, MATH1, COMMON_MATH3, MATH3, CURVE,
     COMMON_MATRIX, REGRESSIONS, DONNEES_POINTS;
use TEXT_IO, FIO, COMMON_MATH0, MATH0, MATH1, COMMON_MATH3, MATH3, CURVE,
    COMMON_MATRIX, REGRESSIONS, DONNEES_POINTS;

procedure DEM_CIRC is
n: NATURAL;

procedure TRACE_REGRESSION_CIRCULAIRE(x, y: in VECTEUR; a, b, r: in FLOAT) is
xMin,yMin,xMax,yMax: FLOAT;
begin
    EXTREMA_POINTS(x,y,xMin,xMax,yMin,yMax);
    xMin := MIN(xMin,a - r) - 0.1*r;
    xMax := MAX(xMax,a + r) + 0.1*r;
    yMin := MIN(yMin,b - r) - 0.1*r;
    yMax := MAX(yMax,b + r) + 0.1*r;
    INIT_GRAPHIQUE;
    FENETRE(xMin,xMax,yMin,yMax);
    CADRE_GRAPHIQUE(0,Y_MAXIMUM - 2*MARGE,MARGE,Y_MAXIMUM - MARGE);
    XY_AXES(a,b,0.1*r,0.1*r,FALSE);
    for j in x'range loop
       CROIX(x(j),y(j));
    end loop;
    CERCLE(a,b,r);
    SORTIE_GRAPHIQUE;
end TRACE_REGRESSION_CIRCULAIRE;

begin
    MODE_AFFICHAGE;
    PUT_LINE("        REGRESSION CIRCULAIRE");
    NEW_LINE(3);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de points du nuage: ");
    declare
       x, y: VECTEUR(1..n);
       a, b, r: FLOAT;
    begin
       ENTRER_POINTS(x,y);
       REGRESSION_CIRCULAIRE(x,y,a,b,r);
       PUT_LINE(IMP,"CERCLE DES MOINDRES CARREES");
       PUT(IMP,"   Centre, (a,b) = ("); FIO.PUT(IMP,a,6,4,0);
       PUT(IMP,","); FIO.PUT(IMP,b,6,4,0); PUT_LINE(IMP,")");
       PUT(IMP,"Rayon, r = "); FIO.PUT(IMP,r,6,4,0);
       NEW_LINE(IMP);
       PAUSE;
       TRACE_REGRESSION_CIRCULAIRE(x,y,a,b,r);
    end;
    CLOSE(IMP);
end DEM_CIRC;
