with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, CURVE,
     MATH2, MATH3, DIRICHLET;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, CURVE,
    MATH2, MATH3, DIRICHLET;

procedure DEM_DIRI is

a, b, ya, yb, y0, y1: FLOAT;
p, q, f: FONCTION;
C: COURBE(300);
CHOIX: INTEGER range 1..3;

procedure DEMO_POISSON is
begin
   MODE_AFFICHAGE;
   PUT_LINE("Resolution de y'' + p(x).y(x) = f(x) sur [0,1] ");
   PUT_LINE("avec p negative et y(0) et y(1) donnes.");
   NEW_LINE;
   GET_LINE(p,"Entrer p(x): ");
   GET_LINE(f,"Entrer f(x): ");
   NEW_LINE;
   ENTRER_REEL(y0,"y(0) = ");
   ENTRER_REEL(y1,"y(1) = ");
   CLRSCR;
   RESOLUTION_POISSON(p,f,y0,y1,C);
   CLOSE(IMP);
end DEMO_POISSON;

procedure DEMO_DIRICHLET is
begin
   MODE_AFFICHAGE;
   PUT_LINE("Resolution d'une equation differentielle lineaire ");
   PUT_LINE("du second ordre avec conditions initiales.");
   NEW_LINE;
   PUT_LINE(" y''(x) + p(x).y'(x) + q(x).y(x) = f(x) (a < x < b )");
   PUT_LINE(" avec y(a) et y(b) donnes.");
   NEW_LINE;
   GET_LINE(p,"Entrer p(x): ");
   GET_LINE(q,"Entrer q(x): ");
   GET_LINE(f,"Entrer f(x): ");
   NEW_LINE;
   ENTRER_REEL(a,"a = ");
   ENTRER_REEL(ya,"ya = ");
   ENTRER_REEL_BORNE(a,1.0E12,b,"b = ");
   ENTRER_REEL(yb,"yb = ");
   CLRSCR;
   RESOLUTION_DIRICHLET(p,q,f,a,b,ya,yb,C);
   CLOSE(IMP);
end DEMO_DIRICHLET;

begin
    loop
       PUT_LINE("Equations differentielles: methode des differences finies");
       NEW_LINE(2);
       PUT_LINE(" -1- Equation du type de Poisson");
       PUT_LINE(" -2- Equation du type de Dirichlet");
       PUT_LINE(" -3- FIN");
       NEW_LINE(2);
       ENTRER_ENTIER_BORNE(1,3,CHOIX," Votre choix: ");
       CLRSCR;
       case CHOIX is
	 when 1 => DEMO_POISSON;
	 when 2 => DEMO_DIRICHLET;
	 when 3 => exit;
       end case;
       if LIRE_REPONSE("Voulez vous l'affichage des resultats? ") then
	  NEW_LINE;
	  for k in 0..C.n
	  loop
	     PUT("x = ");
	     PUT(C.u(k),4,6,0);
	     PUT("     y = ");
	     PUT(C.v(k),4,6,0);
	     NEW_LINE;
	     if ((k + 1) mod 20 = 0) then
		PAUSE;
	     end if;
	   end loop;
       end if;
       NEW_LINE;
       if LIRE_REPONSE("Voulez vous le trace graphique? ") then
	  TRACE_UNE_COURBE(C);
	  SORTIE_GRAPHIQUE;
       else
	  CLRSCR;
       end if;
    end loop;
end DEM_DIRI;
