with TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

PROCEDURE DEM_JAC is
n: NATURAL;
begin
    MODE_AFFICHAGE;
    TEXT_IO.PUT_LINE(IMP,"Resolution d'un systeme lineaire.");
    TEXT_IO.PUT_LINE(IMP,"Methode iterative de Jacobi.");
    TEXT_IO.NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Dimension du systeme: ");
    declare
       A: MATRICE(1..n,1..n);
       b, x: VECTEUR(1..n);
    begin
       DONNEE_MATRICE(A);
       DONNEE_VECTEUR(b);
       TEXT_IO.PUT_LINE(IMP,"RESOLUTION DE A.x = b, AVEC:");
       TEXT_IO.PUT_LINE(IMP," A = ");
       PUT_LINE(A);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP," et b = ");
       PUT_LINE(b);
       PAUSE; CLRSCR;
       CHRONOMETRE(0);
       JACOBI(A,b,x);
       CHRONOMETRE(1);
       TEXT_IO.PUT_LINE(IMP,"La solution est :");
       PUT_LINE(x);
       PAUSE;
    end;
    CLOSE(IMP);
end DEM_JAC;
