with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH2, MATH2,
     COMMON_MATRIX, NIVEAUX;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH2, MATH2,
    COMMON_MATRIX, NIVEAUX;

procedure DEM_NIV is

f: FONCTION;
n, nx, ny: INTEGER;
xMin, xMax, yMin, yMax: FLOAT;

begin
    CLRSCR;
    GET_LINE(f,"f(x,y) = ");
    ENTRER_REEL(xMin,"xMin = ");
    ENTRER_REEL_BORNE(xMin,1.0E+12,xMax,"xMax = ");
    ENTRER_REEL(yMin,"yMin = ");
    ENTRER_REEL_BORNE(yMin,1.0E+12,yMax,"yMax = ");
    ENTRER_ENTIER_BORNE(0,DIM_MAX,nx,"Nombre d'intervalles sur l'axe des x: ");
    ENTRER_ENTIER_BORNE(0,DIM_MAX,ny,"Nombre d'intervalles sur l'axe des y: ");
    ENTRER_ENTIER(n,"Nombre de courbes a tracer: ");
    declare
       U0: VECTEUR(1..n);
       M: MATRICE(0..nx,0..ny);
    begin
       for i in U0'range
       loop
	  PUT("Courbe de niveau numero "); PUT(i); NEW_LINE;
	  ENTRER_REEL(U0(i)," f = ");
       end loop;
       DISCRETISE_FONCTION(f,xMin,xMax,yMin,yMax,M);
       TRACE_EQUIPOTENTIELLES(M,xMin,xMax,yMin,yMax,U0);
    end;
end DEM_NIV;
