with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_POLY, POLY,
     NOMBRES_COMPLEXES, COMMON_MATRIX;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_POLY, POLY,
    NOMBRES_COMPLEXES, COMMON_MATRIX;

procedure DEM_POL is
Choix: INTEGER range 0..2;

procedure DEMO_NEWTON_MAEHLY is
n: INDICE_COEFFICIENTS;
begin
    MODE_AFFICHAGE;
    PUT_LINE("Calcul de toutes les racines reelles d'un polynome");
    PUT_LINE("Methode de Newton-Maehly");
    PUT_LINE("On suppose que toutes les racines du polynome sont reelles");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_DEGRE,n,"Degre du polynome: ");
    declare
       P: POLYNOME(0..n);
       x: VECTEUR(1..n);
    begin
       PUT_LINE("Entrer le polynome P");
       GET(P);
       NEW_LINE;
       NEWTON_MAEHLY(P,x);
       for i in x'range
       loop
	  PUT(IMP,"Solution "); PUT(IMP,i,3); PUT(IMP," = ");
	  PUT(IMP,x(i),5,6,0); NEW_LINE(IMP);
       end loop;
   end;
   CLOSE(IMP);
end DEMO_NEWTON_MAEHLY;

procedure DEMO_BAIRSTOW is
n: INDICE_COEFFICIENTS;
begin
    MODE_AFFICHAGE;
    PUT_LINE("Calcul de toutes les racines complexes d'un polynome");
    PUT_LINE("Methode de Bairstow");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_DEGRE,n,"Degre du polynome: ");
    declare
       P: POLYNOME(0..n);
       x: VECTEUR_COMPLEXE(1..n);
    begin
       PUT_LINE("Entrer le polynome P");
       GET(P);
       NEW_LINE;
       BAIRSTOW(P,x);
       for i in x'range
       loop
	  PUT(IMP,"Solution "); PUT(IMP,i,3); PUT(IMP," = ");
	  PUT(IMP,x(i),5,6,0); NEW_LINE(IMP);
       end loop;
   end;
   CLOSE(IMP);
end DEMO_BAIRSTOW;

begin
  loop
    CLRSCR;
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Recherches des racines reelles d'un polynome");
    PUT_LINE("    Methode de Newton-Maehly");
    PUT_LINE("-2- Recherche des racines complexes d'un polynome");
    PUT_LINE("    Methode de Bairstow");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,Choix,"Votre choix: ");
    case Choix is
      when 0 => exit;
      when 1 => DEMO_NEWTON_MAEHLY; PAUSE;
      when 2 => DEMO_BAIRSTOW; PAUSE;
    end case;
  end loop;
end DEM_POL;

