with TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

PROCEDURE Dem_QR is
n: NATURAL;
BEGIN
    MODE_AFFICHAGE;
    TEXT_IO.PUT_LINE(IMP,
      "Decomposition A = Q*R, avec: Q orthogonale R triangulaire superieure");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Entrer la dimension de la matrice");
    declare
       A, Q, R: MATRICE(1..n,1..n);
       b: VECTEUR(1..n);
    begin
       DONNEE_MATRICE(A);
       TEXT_IO.PUT_LINE(IMP,"Matrice A:");
       PUT_LINE(A);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Calcul de la decomposition Q*R ...");
       DECOMPOSITION_QR(A,Q,R);
       TEXT_IO.PUT_LINE(IMP,"Matrice Q:");
       PUT_LINE(Q);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Matrice R:");
       PUT_LINE(R);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Determinant de A.");
       PUT(IMP,"Det(A) = Det(R) = ");
       FIO.PUT(IMP,DET_MATRICE_TRIANGULAIRE(R),6,4,0);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(Imp,"Resolution de A*x = b.");
       PAUSE;
       DONNEE_VECTEUR(b);
       b := TRANSPOSE(Q)*b;
       SYSTEME_TRIANGULAIRE_SUPERIEUR(R,b,b);
       TEXT_IO.PUT_LINE(IMP,"Solution x:");
       PUT_LINE(b);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Verification A*x = ");
       b := A*b;
       PUT_LINE(b);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Inverse de A");
       R := INV_MATRICE_TRIANG_SUP(R);
       Q := R*TRANSPOSE(Q);
       PUT_LINE(Q);
       PAUSE; CLRSCR;
       TEXT_IO.PUT_LINE(IMP,"Verification A*Inv(A) = ");
       A := A*Q;
       PUT_LINE(A);
       PAUSE;
    end;
    CLOSE(IMP);
end DEM_QR;
