with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
     DONNEES_ALGEBLIN, SPECTRE;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
    DONNEES_ALGEBLIN, SPECTRE;

PROCEDURE DEM_RUTI is
n: NATURAL;
begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"Valeurs propres d'une matrice: Methode de Rutishauser");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Dimension de la matrice: ");
    declare
       A: MATRICE(1..n,1..n);
       V: VECTEUR(1..n);
       S: FLOAT;
    begin
       DONNEE_MATRICE(A);
       S := TRACE(A);
       PUT_LINE(IMP,"Valeurs propres de la matrice A = ");
       PUT_LINE(A);
       NEW_LINE(IMP);
       PAUSE; CLRSCR;
       CHRONOMETRE(0);
       RUTISHAUSER(A,V);
       CHRONOMETRE(1);
       NEW_LINE(IMP);
       PUT_LINE(IMP,"Les valeurs propres sont: ");
       PUT_LINE(V);
       PAUSE; CLRSCR;
       PUT_LINE(IMP,"Verification");
       NEW_LINE(IMP);
       PUT(IMP,"Trace de A = ");
       PUT(IMP,S,5,5,0);
       NEW_LINE(IMP);
       PUT(IMP,"Somme des valeurs propres = ");
       S := 0.0;
       for i in V'range
       loop
	  S := S + V(i);
       end loop;
       PUT(IMP,S,5,5,0);
       NEW_LINE(IMP);
    end;
    CLOSE(IMP);
end DEM_RUTI;
