with TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
     DONNEES_ALGEBLIN, SPECTRE;
use TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
    DONNEES_ALGEBLIN, SPECTRE;

PROCEDURE DEM_SOU is
n: NATURAL;
begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"Calcul du polynome caracteristique: Methode de Souriau");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Dimension de la matrice: ");
    declare
       A, INV: MATRICE(1..n,1..n);
       t: VECTEUR(0..n);
    begin
       DONNEE_MATRICE(A);
       PUT(IMP,"Polynome caracteristique (puissances decroissantes)");
       PUT_LINE(IMP," de la matrice A = ");
       PUT_LINE(A);
       NEW_LINE(IMP);
       PAUSE; CLRSCR;
       CHRONOMETRE(0);
       SOURIAU(A,t,INV);
       CHRONOMETRE(1);
       PUT(IMP,"P(x) = ");
       PUT_LINE(T);
       NEW_LINE(IMP);
       PAUSE;
       PUT_LINE(IMP,"Inverse de A: ");
       PUT_LINE(INV);
    end;
    CLOSE(IMP);
end DEM_SOU;
