with CRT, TEXT_IO, MATH0, COMMON_MATRIX, DONNEES_POINTS, SPLINE;
use CRT, TEXT_IO, MATH0, COMMON_MATRIX, DONNEES_POINTS, SPLINE;

procedure DEM_SPL is

CHOIX: NATURAL range 0..2;

procedure DEMO_SPLINE_CARTESIENNE is
n: NATURAL;
begin
    PUT_LINE("      INTERPOLATION SPLINE CUBIQUE D'UNE COURBE CARTESIENNE");
    NEW_LINE(3);
    PUT_LINE("Les abscisses des points sont strictement croissantes.");
    ENTRER_ENTIER_BORNE(4,DIM_MAX,n,"Nombre de points du nuage (> 3): ");
    declare
       x, y: VECTEUR(1..n);
    begin
       ENTRER_POINTS(x,y,TRUE);
       PUT_LINE("TRACE DE LA COURBE D'INTERPOLATION SPLINE CUBIQUE");
       TRACE_SPLINE_NATUREL(x,y);
    end;
end DEMO_SPLINE_CARTESIENNE;
-- 
procedure DEMO_SPLINE_PARAMETRIQUE is
n: NATURAL;
begin
    PUT_LINE("      INTERPOLATION SPLINE CUBIQUE D'UNE COURBE PARAMETRIQUE");
    NEW_LINE(3);
    ENTRER_ENTIER_BORNE(4,DIM_MAX,n,"Nombre de points du nuage (> 3): ");
    declare
       x, y: VECTEUR(1..n);
    begin
       ENTRER_POINTS(x,y,FALSE);
       PUT_LINE("TRACE DE LA COURBE D'INTERPOLATION SPLINE CUBIQUE");
       TRACE_SPLINE_PARAMETRIQUE(x,y);
    end;
end DEMO_SPLINE_PARAMETRIQUE;
-- 
procedure MENU_SPLINE(CHOIX: out NATURAL) is
begin
    CLRSCR;
    PUT_LINE("         INTERPOLATION SPLINE CUBIQUE");
    NEW_LINE(2);
    PUT_LINE("-0- FIN");
    PUT_LINE("-1- Interpolation spline d'une courbe cartesienne");
    PUT_LINE("-2- Interpolation spline d'une courbe parametrique");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,2,CHOIX,"Votre choix: ");
    CLRSCR;
end MENU_SPLINE;
-- 
begin
   loop
      MENU_SPLINE(CHOIX);
      case CHOIX is
	when 0 => exit;
	when 1 => DEMO_SPLINE_CARTESIENNE;
	when 2 => DEMO_SPLINE_PARAMETRIQUE;
      end case;
   end loop;
end DEM_SPL;

