with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH2,
     SYSTEME_EQUATIONS_GENERIQUE;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, MATH2;

procedure DEM_SYST is
MAX_FONCTIONS: constant INTEGER := 10;
subtype INDICE_FCT is INTEGER range 1..MAX_FONCTIONS;
type SYSTEME_EQUATIONS is array(INDICE_FCT range <>) of FONCTION;

n: INTEGER;
begin
    MODE_AFFICHAGE;
    PUT_LINE ("      SYSTEME DE N EQUATIONS NON LINEAIRES");
    NEW_LINE;
    PUT_LINE("           METHODE DE NEWTON_RAPHSON");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,MAX_FONCTIONS,n,"Nombre d'equations: ");
    NEW_LINE;
    declare
       FF: SYSTEME_EQUATIONS(1..n);
       x: VARIABLE_2(1..n);
       function f(j: in POSITIVE; x: in VARIABLE_2) return FLOAT is
       begin
	   return EVALUE(FF(j),0.0,x);
       end f;

       package SYSTEME_FF is new SYSTEME_EQUATIONS_GENERIQUE(F);
       use SYSTEME_FF;

    begin
       for j in x'range
       loop
	  PUT("Equation Numero "); PUT(j,2); NEW_LINE;
	  PUT("f(");
	  for k in 1..n - 1
	  loop
	     PUT("y"); PUT(k,2); PUT(",");
	  end loop;
	  PUT("y"); PUT(n,2); PUT_LINE(") = ");
	  GET_LINE(ff(j),"   ");
       end loop;
       NEW_LINE;
       PUT_LINE(" Valeur initiale x");
       NEW_LINE;
       for j in x'range
       loop
	  PUT("Valeur initiale x"); PUT(j,2); NEW_LINE;
	  ENTRER_REEL(x(j),"  x = ");
       end loop;
       NEW_LINE;
       NEWTON_RAPHSON(x);
       PUT_LINE("Solution");
       for i in x'range
       loop
	  PUT(IMP,"x"); PUT(IMP,i,2); PUT(IMP," = ");
	  PUT(IMP,x(i),5,6,0);
	  NEW_LINE(IMP);
       end loop;
    end;
    CLOSE(IMP);
end DEM_SYST;

