with TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

procedure DEM_TRID is
n: NATURAL;

begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"    RESOLUTION D'UN SYSTEME LINEAIRE TRIDIAGONAL");
    PUT_LINE(IMP,"       METHODE DES PIVOTS DE GAUSS");
    NEW_LINE(IMP);
    PUT_LINE("Attention: la methode est valable si il n'y a pas de");
    PUT_LINE("permutations dans la methode de Gauss.");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,DIM_MAX,n,"Dimension du systeme: ");
    declare
	A: MATRICE_TRIDIAGONALE(1..n);
	b: VECTEUR(1..n);
    begin
	DONNEE_MATRICE_TRIDIAGONALE(A);
	DONNEE_VECTEUR(b);
	PUT_LINE(IMP,"    SYSTEME AVANT PIVOTAGE");
	PUT_LINE("MATRICE A:");
	PUT_LINE(A);
	PAUSE;
	PUT_LINE(IMP,"VECTEUR b");
	PUT_LINE(b);
	PAUSE;
	CLRSCR;
	SYSTEME_TRIDIAGONAL(A,b);
	PUT_LINE(IMP,"      SOLUTION DU SYSTEME");
	PUT_LINE(b);
    end;
    CLOSE(IMP);
end DEM_TRID;


