with TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

procedure DEM_VAND is
n: NATURAL;

begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"    INVERSE D'UNE MATRICE DE VAN DER MONDE");
    NEW_LINE(IMP,5);
    ENTRER_ENTIER_BORNE(0,10,n,
      "Dimension du vecteur definissant la matrice (< 10): ");
    declare
	A, INV: MATRICE(1..n,1..n);
	x: VECTEUR(1..n);
    begin
	DONNEE_VECTEUR(x);
	MATRICE_VAN_DER_MONDE(x,A);
	PUT_LINE("    MATRICE DE VAN DER MONDE ASSOCIEE");
	PUT_LINE(A);
	PAUSE;
	CLRSCR;
	PUT_LINE("    INVERSE DE LA MATRICE");
	INV := INVERSE_VAN_DER_MONDE(x);
	PUT_LINE(INV);
	PAUSE;
	CLRSCR;
	PUT_LINE("VERIFICATION: A*INV = ");
	PUT_LINE(A*INV);
	PAUSE;
	CLRSCR;
    end;
    CLOSE(IMP);
end DEM_VAND;


