--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE DIRICHLET     
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage on trouvera des procedures de resolution d'une       
-- equation differentielle de type Dirichlet.                             
--ͼ
with CURVE, MATH2;
use CURVE, MATH2;

package DIRICHLET is

procedure RESOLUTION_DIRICHLET(p, q, f: in FONCTION; a, b, ya, yb: in FLOAT;
			       C: in out COURBE);
procedure RESOLUTION_POISSON(p, f: in FONCTION; y0, y1: in FLOAT;
			     C: in out COURBE);
end DIRICHLET;
