--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--               SPECIFICATION DU PAQUETAGE EDP_ELLIPTIQUES 
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'une e.d.p
-- de type elliptique par la methode des differences finies.              
--ͼ
with MATH2, COMMON_MATRIX;
use MATH2, COMMON_MATRIX;

package EDP_ELLIPTIQUES is

procedure RESOLUTION_POISSON(f, g1, g2, g3, g4: in FONCTION;
			     RHO_JACOBI, h: in FLOAT;
			     U: in out MATRICE);
PROCEDURE RESOLUTION_ELLIPTIQUE(
		  f, g1, g2, g3, g4, Alpha, Beta, Gama, Delt, Epsi: FONCTION;
		  Omega, h: in FLOAT;
		  U: in out MATRICE);
procedure AFFICHER_SOLUTION(U: in MATRICE);
procedure RESOLUTION_POISSON_2(f, g1, g2, g3, g4, h1, h2, h3, h4: in FONCTION;
			       p , q , r , s: in INTEGER;
			       RHO_JACOBI, h: in FLOAT;
			       U: in out MATRICE);
procedure AFFICHER_SOLUTION_2(p, q, r, s: in INTEGER; U: in MATRICE);

ERREUR_CONVERGENCE: exception;

end EDP_ELLIPTIQUES;
