--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                           EQUATIONS_GENERIQUE            
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'une      
-- equation numerique f(x) = 0.                                           
--ͼ

generic
  with function f(x: in FLOAT) return FLOAT;
package EQUATIONS_GENERIQUE is

procedure DICHOTOMIE(a, b: in FLOAT;
		     x: out FLOAT; Eps: in FLOAT := 1.0E-6);
procedure NEWTON_RAPHSON(x0: in FLOAT; x: out FLOAT; Eps: in FLOAT := 1.0E-6);
ERREUR_CONVERGENCE: exception;

end EQUATIONS_GENERIQUE;
