with TEXT_IO, COMMON_CRT, CRT, MATH0;
use COMMON_CRT, CRT, MATH0;

procedure LIRE_FONCTION(Msg: in out STRING) is

SYMB: CHARACTER;
MSG_X: COLONNE_TEXTE;
MSG_Y: LIGNE_TEXTE;
L: NATURAL;
np: INTEGER;
CORRECT: BOOLEAN := FALSE;

procedure DECALER(MSG_X, MSG_Y: in NATURAL; Msg: in out STRING) is
-- Si la touche d'effacement est appuyee, alors le dernier caractere de Msg
-- est efface.
begin
    if (L = 0) then
       BIP; -- L est la longueur effective de la chaine
    else
       case Msg(L) is
	  when '(' => np := np - 1;
	  when ')' => np := np + 1;
	  when others => null;
       end case;
       Msg(L) := ' ';
       L := L - 1;
       GOTOXY(MSG_X,MSG_Y);
       CLREOL;
       if (L > 0) then
	  PUT_STRING(Msg(1..L));
       end if;
    end if;
end DECALER;

procedure AVANCER(SYMB: in CHARACTER; Msg: in out STRING) is
-- Permet de lire un caractere supplementaire de Msg. Ce dernier ne sera
-- pas pris en compte s'il n'est pas dans un ensemble de symboles autorises
-- construit en fonction de l'etat de Msg.
-- Le caractere correct est alors place en derniere position de Msg s'il
-- reste encore de la place.
k: NATURAL;
procedure LIRE_A is
begin
 if (k > 0) then
    case Msg(k) is
       when 'G' => CORRECT := (SYMB = 'M');
       when 'M' => CORRECT := (SYMB = '(');
       when 'R' => CORRECT := (SYMB = 'C');
       when 'T' => CORRECT := (SYMB = 'N');
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'B') or (SYMB = 'R');
       when others => CORRECT := FALSE;
    end case;
  else
       CORRECT := (SYMB = 'B') or (SYMB = 'R');
  end if;
end LIRE_A;
procedure LIRE_B is
begin
 if (k > 0) then
   if (Msg(k) = 'A') then
      CORRECT := (SYMB = 'S');
   else
      CORRECT := FALSE;
   end if;
 else
   CORRECT := FALSE;
 end if;
end LIRE_B;
procedure LIRE_C is
begin
 if (k > 0) then
    case Msg(k) is
       when 'R' => CORRECT := (SYMB = 'C') or (SYMB = 'S') or (SYMB = 'T');
       when 'A' => CORRECT := (SYMB = '(');
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'O') or (SYMB = 'H');
       when others => CORRECT := FALSE;
    end case;
  else
       CORRECT := (SYMB = 'H')  or (SYMB = 'O');
  end if;
end LIRE_C;
procedure LIRE_E is
begin
    if (k > 0) then
       case Msg(k) is
	  when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'X') or (SYMB = '-') or (SYMB = '+') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = ')') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB = CHARACTER'VAL(13));
	  when others => CORRECT := FALSE;
	end case;
    else
       CORRECT := (SYMB = 'X') or (SYMB = '-') or (SYMB = '+') or
		  (SYMB = '/') or (SYMB = '*') or (SYMB = CHARACTER'VAL(94))
	       or (SYMB = CHARACTER'VAL(13));
    end if;
end LIRE_E;
procedure LIRE_F is
begin
  if (k > 0) then
    case Msg(k) is
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
	 CORRECT := (SYMB = 'R');
       when others => CORRECT := FALSE;
    end case;
  else
    CORRECT := FALSE;
  end if;
end LIRE_F;
procedure LIRE_G is
begin
  if (k > 0) then
     case Msg(k) is
       when 'T' => CORRECT := (SYMB = '(');
       when 'R' => CORRECT := (SYMB = 'C') or (SYMB = 'S') or (SYMB = 'T');
       when 'N' => CORRECT := (SYMB = 'A');
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'A');
       when others => CORRECT := FALSE;
     end case;
   else
     CORRECT := (SYMB = 'A');
   end if;
end LIRE_G;
procedure LIRE_H is
begin
   if (k > 0) then
      case Msg(k) is
	when 'C'|'S'|'T' => CORRECT := (SYMB = '(');
	when others => CORRECT := FALSE;
      end case;
    else
      CORRECT := FALSE;
    end if;
end LIRE_H;
procedure LIRE_I is
begin
 if (k > 0) then
    case Msg(k) is
       when 'S' => CORRECT := (SYMB = 'N');
       when 'P' => CORRECT := (SYMB = '-') or (SYMB = '+') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = ')') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB = CHARACTER'VAL(13));
       when others => CORRECT := FALSE;
    end case;
  end if;
end LIRE_I;
procedure LIRE_L is
begin
    if (k > 0) then
       case Msg(k) is
	 when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
	       CORRECT := (SYMB = 'N');
	 when others => CORRECT := FALSE;
       end case;
    else
       CORRECT := (SYMB = 'N');
    end if;
end LIRE_L;
procedure LIRE_M is
begin
 if (k > 0) then
    case Msg(k) is
       when 'A' => CORRECT := (SYMB = 'M');
       when 'M' => CORRECT := (SYMB = 'A');
       when others => CORRECT := FALSE;
    end case;
 end if;
end LIRE_M;
procedure LIRE_N is
begin
 if (k > 0) then
    case Msg(k) is
       when 'L' => CORRECT := (SYMB = '(') or (SYMB = 'G');
       when 'I'|'A' => CORRECT := (SYMB = '(');
       when others => CORRECT := FALSE;
    end case;
 end if;
end LIRE_N;
procedure LIRE_O is
begin
   if (k > 0) then
     if (Msg(k) = 'C') then
	CORRECT := (SYMB = 'S');
     else
	CORRECT := FALSE;
     end if;
   else
     CORRECT := FALSE;
   end if;
end LIRE_O;
procedure LIRE_P is
begin
 if (k > 0) then
    case Msg(k) is
       when 'X' => CORRECT := (SYMB = '(');
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'I');
       when others => CORRECT := FALSE;
    end case;
  else
       CORRECT := (SYMB = 'I');
  end if;
end LIRE_P;
procedure LIRE_Q is
begin
    if (k > 0) then
       if (Msg(k) = 'S') then
	  CORRECT := (SYMB = 'R');
       else
	  CORRECT := FALSE;
       end if;
     else
       CORRECT := FALSE;
     end if;
end LIRE_Q;
procedure LIRE_R is
begin
 if (k > 0) then
    case Msg(k) is
       when 'A' => CORRECT := (SYMB = 'C') or (SYMB = 'G');
       when 'F' => CORRECT := (SYMB = 'A');
       when 'Q' => CORRECT := (SYMB = 'T');
       when others => CORRECT := FALSE;
    end case;
 end if;
end LIRE_R;
procedure LIRE_S is
begin
 if (k > 0) then
    case Msg(k) is
       when 'O'|'B' => CORRECT := (SYMB = '(');
       when 'G' => CORRECT := (SYMB = 'H');
       when 'C' => CORRECT := (SYMB = 'I');
       when '+'|'-'|'*'|'/'|CHARACTER'VAL(94) |'(' =>
		   CORRECT := (SYMB = 'I') or (SYMB = 'H') or (SYMB = 'Q');
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = 'I') or (SYMB = 'H') or (SYMB = 'Q');
 end if;
end LIRE_S;
procedure LIRE_T is
begin
 if (k > 0) then
    case Msg(k) is
       when 'R' => CORRECT := (SYMB = '(');
       when 'C' => CORRECT := (SYMB = 'A');
       when 'G' => CORRECT := (SYMB = 'H');
       when '('|'+'|'-'|'*'|'/'|CHARACTER'VAL(94) =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = CHARACTER'VAL(13))
		or (SYMB = CHARACTER'VAL(94)) or (SYMB = 'H') or (SYMB = 'G');
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = CHARACTER'VAL(13)) or
		  (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		  (SYMB = '/') or (SYMB = CHARACTER'VAL(94)) or
		  (SYMB = 'H') or (SYMB = 'G');
 end if;
end LIRE_T;
procedure LIRE_X is
begin
 if (k > 0) then
    case Msg(k) is
       when 'E' => CORRECT := (SYMB = 'P');
       when '('|'+'|'-'|'*'|'/'|CHARACTER'VAL(94) =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB = CHARACTER'VAL(13));
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = CHARACTER'VAL(13)) or
		  (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		  (SYMB = '/') or (SYMB = CHARACTER'VAL(94));
 end if;
end LIRE_X;
procedure LIRE_Y is
begin
 if (k > 0) then
    case Msg(k) is
       when '('|'+'|'-'|'*'|'/'|CHARACTER'VAL(94) =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = CHARACTER'VAL(13))
		or (SYMB = CHARACTER'VAL(94)) or (SYMB in '0'..'9');
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = CHARACTER'VAL(13)) or (SYMB in '0'..'9') or
		  (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		  (SYMB = '/') or (SYMB = CHARACTER'VAL(94));
 end if;
end LIRE_Y;
procedure LIRE_Z is
begin
 if (k > 0) then
    case Msg(k) is
       when '('|'+'|'-'|'*'|'/'|CHARACTER'VAL(94) =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB = CHARACTER'VAL(13));
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = CHARACTER'VAL(13)) or
		  (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		  (SYMB = '/') or (SYMB = CHARACTER'VAL(94));
 end if;
end LIRE_Z;
procedure LIRE_ZERO is
begin
 if (k > 0) then
    case Msg(k) is
       when 'Y' =>
	    CORRECT := (SYMB = CHARACTER'VAL(13)) or (SYMB = ')') or
		  (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		  (SYMB = '/') or (SYMB = CHARACTER'VAL(94));
       when '('|'+'|'-'|'*'|'/'|CHARACTER'VAL(94) =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = '.') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB in '0'..'9');
       when '.'|'0'..'9' =>
		   CORRECT := (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		   (SYMB = '*') or (SYMB = '/') or (SYMB = '.') or
		   (SYMB = CHARACTER'VAL(94)) or (SYMB in '0'..'9')
		   or (SYMB = CHARACTER'VAL(13));
       when others => CORRECT := FALSE;
    end case;
 else
       CORRECT := (SYMB = '.') or (SYMB = CHARACTER'VAL(13));
 end if;
end LIRE_ZERO;
procedure LIRE_PF is
begin
   if (k > 0) then
      case Msg(k) is
	 when ')'|'X'|'T'|'Y'|'E'|'I'|'0'..'9' =>
	   CORRECT := (SYMB = CHARACTER'VAL(13)) or
		      (SYMB = ')') or (SYMB = '+') or (SYMB = '-') or
		      (SYMB = '*') or (SYMB = '/') or
		      (SYMB = CHARACTER'VAL(94));
	 when others => CORRECT := FALSE;
       end case;
    else
       CORRECT := FALSE;
    end if;
end LIRE_PF;
procedure LIRE_PT is
begin
    if (k > 0) then
       if (Msg(k) in '0'..'9') then
	  CORRECT := (SYMB in '0'..'9');
       else
	  CORRECT := FALSE;
       end if;
    else
       CORRECT := FALSE;
    end if;
end LIRE_PT;

begin -- De Avancer
    if (L = 0) then
       CORRECT := (SYMB = 'X') or (SYMB = 'T') or (SYMB = 'Y') or
		  (SYMB = '-') or (SYMB = '(') or (SYMB = 'A') or
		  (SYMB = 'C') or (SYMB = 'E') or (SYMB = 'F') or
		  (SYMB = 'G') or (SYMB = 'L') or (SYMB = 'P') or
		  (SYMB = 'S') or (SYMB in '0'..'9');
    else
       k := L - 1;
       case Msg(L) is
	  when 'A' => LIRE_A;
	  when 'B' => LIRE_B;
	  when 'C' => LIRE_C;
	  when 'E' => LIRE_E;
	  when 'F' => LIRE_F;
	  when 'G' => LIRE_G;
	  when 'H' => LIRE_H;
	  when 'I' => LIRE_I;
	  when 'L' => LIRE_L;
	  when 'M' => LIRE_M;
	  when 'N' => LIRE_N;
	  when 'O' => LIRE_O;
	  when 'P' => LIRE_P;
	  when 'Q' => LIRE_Q;
	  when 'R' => LIRE_R;
	  when 'S' => LIRE_S;
	  when 'T' => LIRE_T;
	  when 'X' => LIRE_X;
	  when 'Y' => LIRE_Y;
	  when 'Z' => LIRE_Z;
	  when '0' => LIRE_ZERO;
	  when ')' => LIRE_PF;
	  when '.' => LIRE_PT;
	  when others => CORRECT := FALSE;
       end case;
       if Msg(L) in '1'..'9' then
	  CORRECT := (SYMB = CHARACTER'VAL(13)) or (SYMB = ')') or
		     (SYMB = '+') or (SYMB = '-') or (SYMB = '*') or
		     (SYMB = '/') or (SYMB = CHARACTER'VAL(94)) or (SYMB = '.') or
		     (SYMB in '0'..'9');
       end if;
       if (Msg(L) = '+') or (Msg(L) = '-') or (Msg(L) = '*') or
	  (Msg(L) = '/') or (Msg(L) = '(') or
	  (Msg(L) = CHARACTER'VAL(94)) then
	  CORRECT := (SYMB = 'X') or (SYMB = 'T') or (SYMB = 'Y') or (SYMB = 'Z') or
		     (SYMB = '-') or (SYMB = '(') or (SYMB = 'A') or (SYMB = 'C') or
		     (SYMB = 'E') or (SYMB = 'F') or (SYMB = 'G') or (SYMB = 'L') or
		     (SYMB = 'P') or (SYMB = 'S') or (SYMB in '0'..'9');
       end if;
    end if;
    if ( CORRECT ) and (SYMB /= CHARACTER'VAL(13)) then
       PUT_CHAR(SYMB);
       if (SYMB = '(') then
	  np := np + 1;
	end if;
	if (SYMB = ')') then
	   np := np - 1;
	end if;
	if (L < Msg'LENGTH) then
	   L := L + 1;
	   Msg(L) := SYMB;
	else
	   BIP;
	end if;
    else
	if (SYMB /= CHARACTER'VAL(13)) then
	   BIP;
	   return;
	end if;
    end if;
end AVANCER;

begin -- Corps principal de LIRE_FONCTION.
   MSG_X := WHERE_X; MSG_Y := WHERE_Y;
   loop
      Msg := (others => ' ');
      L := 0; np := 0;
      loop
	 SYMB := READKEY;
	 if (SYMB = CHARACTER'VAL(08)) then
	    DECALER(MSG_X,MSG_Y,Msg);
	 else
	    SYMB := MAJUSCULE(SYMB);
	    AVANCER(SYMB,Msg);
	 end if;
	 exit when (SYMB = CHARACTER'VAL(13)) and (CORRECT);
      end loop;
      if (np /= 0) then
	 TEXT_IO.NEW_LINE;
	 BIP;
	 PUT_STRING(" Nombre de parentheses incorrect, recommencer");
	 PAUSE;
	 GOTOXY(1,MSG_Y + 1); CLREOL;
	 GOTOXY(MSG_X,MSG_Y); CLREOL;
       end if;
       exit when (np = 0);
    end loop;
end LIRE_FONCTION;

