with TEXT_IO, IIO;
use TEXT_IO, IIO;

procedure LIST is

FICHIER_A_IMPRIMER, LST: FILE_TYPE;
NUMERO_DE_LIGNE: INTEGER;
NOM_DE_FICHIER: STRING(1..80);
TAILLE: NATURAL;

procedure INITIALISE is
begin
  loop
    begin
      NOM_DE_FICHIER := (others => ' ');
      PUT("Nom du fichier a imprimer: ");
      GET_LINE(NOM_DE_FICHIER,TAILLE);
      OPEN(FICHIER_A_IMPRIMER,IN_FILE,NOM_DE_FICHIER(1..TAILLE));
      exit;
    exception
	when NAME_ERROR =>
	  PUT_LINE("Nom de fichier incorrect, recommencer: ");
    end;
  end loop;
  NUMERO_DE_LIGNE:= 1;
  OPEN(LST,OUT_FILE,"PRN");
  SET_LINE_LENGTH(LST,135);
  SET_PAGE_LENGTH(LST,60);
  PUT(LST,CHARACTER'VAL(15)); -- Impression en mode condense
  NEW_LINE(LST);
end INITIALISE;

procedure LIT_ET_IMPRIME_UNE_LIGNE is
C: CHARACTER;
begin
  PUT(LST,"      ");
  PUT(LST,NUMERO_DE_LIGNE);
  PUT(LST,"  ");
  while (not END_OF_LINE(FICHIER_A_IMPRIMER))
  loop
    GET(FICHIER_A_IMPRIMER,C);
    PUT(LST,C);
  end loop;
  SKIP_LINE(FICHIER_A_IMPRIMER);
  NEW_LINE(LST);
  NUMERO_DE_LIGNE:= (NUMERO_DE_LIGNE + 1);
end LIT_ET_IMPRIME_UNE_LIGNE;

procedure IMPRIME_EN_TETE is
begin
    NEW_LINE(LST);
    PUT(LST,"         Fichier: ");
    PUT(LST,NOM_DE_FICHIER(1..TAILLE));
    PUT(LST,"   Page");
    PUT(LST,COUNT'IMAGE(PAGE(LST)));
    NEW_LINE(LST,2);
    PUT("Fichier: ");
    PUT(NOM_DE_FICHIER(1..TAILLE));
    PUT("   page");
    PUT(COUNT'IMAGE(PAGE(LST)));
    NEW_LINE;
end IMPRIME_EN_TETE;

begin
  INITIALISE;
  loop
   begin
     IMPRIME_EN_TETE;
     for i in LINE(LST)..PAGE_LENGTH(LST)
     loop
	LIT_ET_IMPRIME_UNE_LIGNE; -- Si la derniere page contient moins de
				     -- 60 lignes l'exception END_ERROR
				     -- sera levee
     end loop;
   exception
     when END_ERROR => NEW_PAGE(LST); exit;
   end;
  end loop;
  PUT(LST,CHARACTER'VAL(18)); -- Impression en mode normal: 10 Cpi
  CLOSE(FICHIER_A_IMPRIMER);
end LIST;
