--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1992             
--                    SPECIFICATION DU PAQUETAGE MATH3      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des procedures destinees a travailler en  
-- mode graphique, en coordonnees reelles.                                
--ͼ

package MATH3 is

procedure INIT_GRAPHIQUE;
procedure MODE_TEXTE;
procedure MESSAGE_ERREUR_GRAPHIQUE(Msg: in STRING);
procedure TEST_MODE_GRAPHIQUE(Msg: in STRING);
procedure FENETRE(X_FEN_MIN,X_FEN_MAX,Y_FEN_MIN,Y_FEN_MAX: in FLOAT);
procedure CADRE_GRAPHIQUE(X_CADRE_MIN, X_CADRE_MAX,
			  Y_CADRE_MIN, Y_CADRE_MAX: in INTEGER);
procedure FENETRE_GRAPHIQUE(X_FEN_MIN,X_FEN_MAX,
			    Y_FEN_MIN,Y_FEN_MAX: in FLOAT);
procedure CONVERSION(x, y: in FLOAT;
		     X_INFO: out INTEGER;
		     Y_INFO: out INTEGER);
PROCEDURE TEXT_MOVE_TO(x: in INTEGER; y: in INTEGER);
procedure PAUSE_GRAPHIQUE;
procedure DEPLACE(x, y: in FLOAT);
procedure POINT(x, y: in FLOAT);
procedure TRACE_SEGMENT(x1, y1, x2, y2: in FLOAT);
procedure TRACE(x, y: in FLOAT);
procedure CROIX(x, y: in FLOAT);
procedure SORTIE_GRAPHIQUE;
procedure VERIFICATION_SYSTEME;
procedure CERCLE(x, y, r: in FLOAT);
procedure X_AXE(X_ORIGINE, Y_ORIGINE, X_UNITE: in FLOAT);
procedure Y_AXE(X_ORIGINE, Y_ORIGINE, Y_UNITE: in FLOAT);
procedure XY_AXES(X_ORIGINE, Y_ORIGINE, X_UNITE, Y_UNITE: in FLOAT;
		 XY_GRILLE: in BOOLEAN := TRUE);
procedure TITRE(Msg: in STRING);

end MATH3;
