--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                          EQUADIFF_11_GENERIQUE           
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de resolution d'une      
-- equation differentielle d'ordre 1                                      
--ͼ
-- Une equation differentielle d'ordre 1 s'ecrit sous la forme:
--              y' = f(x,y)  x dans (a,b)
--              y(a) donne dans R

with COMMON_MATRIX;
use COMMON_MATRIX;

generic
  with function f11(x, y: in FLOAT) return FLOAT;
package EQUADIFF_11_GENERIQUE is

procedure RESOLUTION_RK4_11(a, b, ya: in FLOAT;
			    AFFICHER: in BOOLEAN; x, y: in out VECTEUR);
procedure RESOLUTION_RK4_11_CONTROLE(a, b, ya: in FLOAT;
				     AFFICHER: in BOOLEAN;
				     x, y: in out VECTEUR);
end EQUADIFF_11_GENERIQUE;
