--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                  SPECIFICATION DU PAQUETAGE SPECTRE      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des procedures de calcul des valeurs et   
-- vecteurs propres d'une matrice.                                        
--ͼ

with COMMON_MATRIX;
use COMMON_MATRIX;
package SPECTRE is
procedure DEFLATION(A: in MATRICE; VALEURS_PROPRES: in out VECTEUR;
				   VECTEURS_PROPRES: in out MATRICE);
procedure RUTISHAUSER(A: in MATRICE; VALEURS_PROPRES: in out VECTEUR);
procedure JACOBI(A: in MATRICE; D: in out VECTEUR; V: in out MATRICE);
procedure SOURIAU(A: in MATRICE; T: in out VECTEUR;
		  INVERSE: in out MATRICE);
end SPECTRE;
