--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE SPLINE        
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de realiser   
-- l'interpolation de Spline cubique.                                     
--ͼ
with COMMON_MATRIX;
use COMMON_MATRIX;
package SPLINE is

procedure CALCUL_COEFFICIENTS_SPLINE_NATUREL(x, y: in VECTEUR;
					     a, b, c, d: out VECTEUR);
function SPL(x, y, a, b, c, d: in VECTEUR; t: in FLOAT) return FLOAT;
procedure TRACE_SPLINE_NATUREL(x, y: in VECTEUR);
procedure CALCUL_COEFFICIENTS_SPLINE_PERIODIQUE(PERIODE: in FLOAT;
						x, y: in VECTEUR;
						a, b, c, d: out VECTEUR);
procedure TRACE_SPLINE_PERIODIQUE(PERIODE: in FLOAT; x, y: in VECTEUR);
procedure TRACE_SPLINE_PARAMETRIQUE(x, y: in VECTEUR);

end SPLINE;
