--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                        SPECIFICATION DU PAQUETAGE        
--                       SYSTEME_EQUATIONS_GENERIQUE        
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera une procedure de resolution d'un        
-- systeme d'equations non lineaires par la methode de Newton-Raphson.    
--ͼ
with COMMON_MATRIX, MATH2;
use COMMON_MATRIX, MATH2;

generic
  with function f(j: in POSITIVE; x: in VARIABLE_2) return FLOAT;

package SYSTEME_EQUATIONS_GENERIQUE is

procedure MATRICE_JACOBIENNE(x: in VARIABLE_2; df: out MATRICE);
procedure NEWTON_RAPHSON(x: in out VARIABLE_2);

ERREUR_CONVERGENCE: exception;

end SYSTEME_EQUATIONS_GENERIQUE;
