--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE BEZIER        
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de realiser   
-- une interpolation de Bezier.                                           
--ͼ

with CURVE, COMMON_MATRIX;
use CURVE, COMMON_MATRIX;

package BEZIER is

function POLYNOME_BERNSTEIN(P: in VECTEUR; t: in FLOAT) return FLOAT;
procedure CALCUL_BEZIER(x, y: in VECTEUR; t: in FLOAT; Bx, By: out FLOAT);
procedure TRACE_BASE_BERNSTEIN(n: in NATURAL);
procedure COURBE_BEZIER(x, y: in VECTEUR; C: in out COURBE);

end BEZIER;
