with TEXT_IO, FIO, MATH0, MATH1, MATH2, MATH3;
use TEXT_IO, FIO, MATH0, MATH1, MATH2, MATH3;

package body CARTESIENNE is

procedure DONNEES_CARTESIENNE(f: in out FONCTION; C: in out COURBE) is
Pas: FLOAT;
begin
    GET_LINE(f,"Entrer la fonction f(x): ");
    ENTRER_REEL(C.uMin,"Valeur minimale de l'abscisse, a = ");
    ENTRER_REEL_BORNE(C.uMin,1.0E+6,C.uMax,
		      "Valeur maximale de l'abscisse, b = ");
    NEW_LINE;
    PAS := (C.uMax - C.uMin)/FLOAT(C.n);
    C.vMIN := 1.0E+37;
    C.vMAX := -C.vMIN;
    C.u(0) := C.uMin;
    C.v(0) := Evalue(f,C.u(0));
    for i in 1..C.n loop
      C.u(i) := C.u(i-1) + PAS;
      C.v(i) := Evalue(f,C.u(i));
      C.vMIN := MIN(C.vMIN,C.v(i-1));
      C.vMAX := MAX(C.vMAX,C.v(i-1));
    end loop;
end DONNEES_CARTESIENNE;
-- 
procedure TRACE_CARTESIENNE(f: in out FONCTION; C: in out COURBE) is
begin
    DONNEES_CARTESIENNE(f,C);
    TRACE_UNE_COURBE(C);
    TITRE("  Graphe de f(x) = " & TEXTE_DE_FONCTION(f));
    SORTIE_GRAPHIQUE;
end TRACE_CARTESIENNE;
-- 

end CARTESIENNE;

