--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--               SPECIFICATION DU PAQUETAGE COMMON_FOURIER  
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
-- Dans ce paquetage on trouvera des definitions utiles pour              
-- transformation de Fourier discrete.                                    
--                                                                        
--ͼ
with NOMBRES_COMPLEXES;
use NOMBRES_COMPLEXES;

package COMMON_FOURIER is
P_MAX: constant INTEGER := 8;
N_MAX: constant INTEGER := 2**P_MAX;
subtype INDICE is INTEGER range 0..N_MAX - 1;
type VECTEUR_COMPLEXE is array(INDICE range <>) of COMPLEXE;

end COMMON_FOURIER;
