--             ͻ
--                             J. E. ROMBALDI              
--                      E.N.S.A.M. CHALONS SUR MARNE       
--                           COPYRIGHT (C) 1993            
--               SPECIFICATION DU PAQUETAGE COMMON_GRAPH   
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des declarations de types et de variables 
-- utilises par GRAPH.                                                    
--ͼ

package COMMON_GRAPH is

type CARTE_GRAPHIQUE is (CGA_C4_320x200, CGA_GREY4_320x200, CGA_C2_640x200,
			 EGA_C16_320x200, EGA_C16_640x200, EGA_BW_640x350,
			 EGA_VGA_C16_320x200, EGA_VGA_C16_640x200,
			 EGA_VGA_BW_640x350, EGA_VGA_C16_640x350,
			 MCGA_BW_640x480, MCGA_C256_320x200,
			 VGA_C16_640x480, SVGA_C16_800x600,
			 SVGA_C16_1024x768);
type COULEUR is (NOIR, BLEUE, VERT, CYAN, ROUGE, MAGENTA, BRUN,
		 GRIS_CLAIR, GRIS_FONCE, BLEUE_CLAIR, VERT_CLAIR,
		 CYAN_CLAIR, ROUGE_CLAIR, MAGENTA_CLAIR, JAUNE, BLANC);
subtype TAILLE_CARACTERE is integer range 8 ..  16;
subtype TEXTE_HORIZONTAL is INTEGER range 0..127;
subtype TEXTE_VERTICAL is INTEGER range 0..47;

CARTE_GRAPHIQUE_UTILISATEUR: CARTE_GRAPHIQUE;
MAX_LIGNE_TEXTE: TEXTE_VERTICAL;
MAX_COLONNE_TEXTE: TEXTE_HORIZONTAL;
CLIP_ON: BOOLEAN;
GR_X_MIN, GR_X_MAX, GR_Y_MIN, GR_Y_MAX, GET_MAX_X, GET_MAX_Y: NATURAL;
LARGEUR_PIXEL, HAUTEUR_PIXEL: TAILLE_CARACTERE;
X_POS, Y_POS: INTEGER;
COULEUR_PIXEL: COULEUR := GRIS_CLAIR;

end COMMON_GRAPH;

