--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--               SPECIFICATION DU PAQUETAGE COMMON_MATRIX   
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on definit les types MATRICE, MATRICE_TRIDIAGONALE  
-- et VECTEUR. Les matrices sont carrees et de dimension au plus DIM_MAX. 
--ͼ

package COMMON_MATRIX is

DIM_MAX: constant NATURAL := 80;
type MATRICE is array(NATURAL range <>,NATURAL range <>) of FLOAT;
type VECTEUR is array(NATURAL range <>) of FLOAT;
type MATRICE_TRIDIAGONALE is array(NATURAL range <>) of VECTEUR(1..3);

ERREUR_DIMENSIONS: exception;
ERREUR_DETERMINANT_NUL: exception;

end COMMON_MATRIX;

