with TEXT_IO, FIO, COMMON_MATH0, MATH0, MATH3, CURVE, COMMON_MATRIX,
     REGRESSIONS, DONNEES_POINTS;
use TEXT_IO, FIO, COMMON_MATH0, MATH0, MATH3, CURVE, COMMON_MATRIX,
    REGRESSIONS, DONNEES_POINTS;

-- Demonstration de la regression affine.

procedure DEM_AFF is
n: NATURAL;

procedure TRACE_REGRESSION_AFFINE(x, y: in VECTEUR; a, b: in FLOAT) is
xMin,yMin,xMax,yMax,xOrigine,yOrigine,xUnite,yUnite: FLOAT;
xFenMin, xFenMax, yFenMin, yFenMax: FLOAT;
begin
    EXTREMA_POINTS(x,y,xMin,xMax,yMin,yMax);
    AXES_PAR_DEFAUT(xMin,yMin,xMax,yMax,xOrigine,yOrigine,xUnite,yUnite,
		    xFenMin, xFenMax, yFenMin, yFenMax);
    INIT_GRAPHIQUE;
    FENETRE_GRAPHIQUE(xFenMin,xFenMax,yFenMin,yFenMax);
    XY_AXES(xOrigine,yOrigine,xUnite,yUnite,FALSE);
    for j in x'range loop
       CROIX(x(j),y(j));
    end loop;
    DEPLACE(xMin,a*xMin + b);
    TRACE(xMax,a*xMax + b);
    SORTIE_GRAPHIQUE;
end TRACE_REGRESSION_AFFINE;

begin
    MODE_AFFICHAGE;
    PUT_LINE("        REGRESSION AFFINE");
    NEW_LINE(3);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Nombre de points du nuage: ");
    declare
       x, y: VECTEUR(1..n);
       a, b, Rho: FLOAT;
    begin
       ENTRER_POINTS(x,y);
       REGRESSION_AFFINE(x,y,a,b,Rho);
       PUT_LINE(IMP,"DROITE DES MOINDRES CARREES");
       PUT(IMP,"   y = "); FIO.PUT(IMP,a,6,4,0); PUT(IMP,"*x + ");
       FIO.PUT(IMP,b,6,4,0);
       NEW_LINE(IMP);
       PUT(IMP,"Coefficient de regression: Rho = ");
       FIO.PUT(IMP,Rho,6,4,0);
       NEW_LINE(IMP);
       PAUSE;
       TRACE_REGRESSION_AFFINE(x,y,a,b);
    end;
    CLOSE(IMP);
end DEM_AFF;
