with TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

procedure Dem_Chol is
n: NATURAL;

begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"    DECOMPOSITION DE CHOLESKY A = B.Transpose(B)");
    NEW_LINE(IMP);
    PUT_LINE("Attention: La decomposition est valable pour");
    PUT_LINE("A symetrique definie positive.");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,DIM_MAX,n,"Dimension de la matrice: ");
    declare
	A, B, INV: MATRICE(1..n,1..n);
	DET: FLOAT;
    begin
	DONNEE_MATRICE(A);
	CHOLESKY(A,B);
	PUT_LINE(IMP,"    MATRICE B");
	PUT_LINE(B);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"    VERIFICATION: B*Transpose(B) = ");
	A := B*TRANSPOSE(B);
	PUT_LINE(A);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"   CALCUL DU DETERMINANT");
	PUT("Det(A) = ");
	DET := DET_MATRICE_TRIANGULAIRE(B);
	FIO.PUT(IMP,DET,6,4,0);
	NEW_LINE;
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"   CALCUL DE L'INVERSE DE A");
	INV := INV_MATRICE_TRIANG_SUP(TRANSPOSE(B))*INV_MATRICE_TRIANG_INF(B);
	PUT_LINE(INV);
	PAUSE;
	CLRSCR;
	PUT_LINE("    VERIFICATION: A*INV(A) =");
	A := A*INV;
	PUT_LINE(A);
	PAUSE;
	CLOSE(IMP);
    end;
end DEM_CHOL;


