with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
     DONNEES_ALGEBLIN, SPECTRE;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
    DONNEES_ALGEBLIN, SPECTRE;

PROCEDURE DEM_DEFL is
n, p: NATURAL;
begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"Valeurs propres d'une matrice: Methode de deflation");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(2,DIM_MAX,n,"Dimension de la matrice: ");
    ENTRER_ENTIER_BORNE(1,n,p,"Nombre de valeurs propres a calculer: ");
    declare
       A: MATRICE(1..n,1..n);
       ValPr: VECTEUR(1..p);
       VectPr: MATRICE(1..n,1..p);
       S: FLOAT;
    begin
       DONNEE_MATRICE(A);
       S := TRACE(A);
       PUT_LINE(IMP,"Valeurs propres de la matrice A = ");
       PUT_LINE(A);
       NEW_LINE(IMP);
       PAUSE; CLRSCR;
       CHRONOMETRE(0);
       DEFLATION(A,ValPr,VectPr);
       CHRONOMETRE(1);
       NEW_LINE(IMP);
       for j in 1..p
       loop
	  PUT(IMP,"Valeur propre Numero ");
	  PUT(IMP,j,2);
	  PUT(IMP," = ");
	  PUT(IMP,ValPr(j),5,5,0);
	  NEW_LINE(IMP);
	  PUT_LINE(IMP,"Vecteur propre associe:");
	  PUT(IMP,"(");
	  for i in 1..n - 1
	  loop
	     PUT(IMP,VectPr(i,j),5,5,0);
	     PUT(IMP,",");
	  end loop;
	  PUT(IMP,VectPr(n,j),5,5,0);
	  PUT_LINE(IMP,")");
	  if (j mod 5 = 0) then
	     PAUSE;
	  end if;
       end loop;
       if (p = n) then
	  PAUSE; CLRSCR;
	  PUT_LINE(IMP,"Verification");
	  NEW_LINE(IMP);
	  PUT(IMP,"Trace de A = ");
	  PUT(IMP,S,5,5,0);
	  NEW_LINE(IMP);
	  PUT(IMP,"Somme des valeurs propres = ");
	  S := 0.0;
	  for i in 1..n
	  loop
	     S := S + ValPr(i);
	  end loop;
	  PUT(IMP,S,5,5,0);
	  NEW_LINE(IMP);
       end if;
    end;
    CLOSE(IMP);
end DEM_DEFL;
