with TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

PROCEDURE DEM_GJ is
n: NATURAL;
begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"      Resolution d'un systeme lineaire.");
    PUT_LINE(IMP,"      Calcul de l'inverse d'une matrice.");
    PUT_LINE(IMP,"       Methode de Gauss-Jordan.");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(1,DIM_MAX,n,"Dimension du systeme: ");
    declare
       A, INV: MATRICE(1..n,1..n);
       b: VECTEUR(1..n);
    begin
       DONNEE_MATRICE(A);
       DONNEE_VECTEUR(b);
       PUT_LINE(IMP,"RESOLUTION DE A.x = b, AVEC:");
       PUT_LINE(IMP," A = ");
       PUT_LINE(A);
       PAUSE; CLRSCR;
       PUT_LINE(IMP," et b = ") ;
       PUT_LINE(b);
       PAUSE; CLRSCR;
       GAUSS_JORDAN(A,b);
       PUT_LINE(IMP,"       Solution, de A.x = b") ;
       NEW_LINE(IMP);
       PUT_LINE(b);
       PAUSE; CLRSCR;
       PUT_LINE(IMP,"Inversion d'une matrice");
       NEW_LINE(IMP);
       DONNEE_MATRICE(A);
       PUT_LINE(IMP,"INVERSION DE LA MATRICE A = ");
       NEW_LINE(IMP);
       PUT_LINE(A);
       PAUSE; CLRSCR;
       PUT_LINE(IMP,"Inv(A) = ");
       NEW_LINE(IMP);
       PUT_LINE(INVERSE_GAUSS_JORDAN(A));
       PAUSE;
       CLOSE(IMP);
    end;
end DEM_GJ;
