with TEXT_IO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

procedure Dem_LR is
n: NATURAL;

begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"    DECOMPOSITION A = L.R DE CROUT");
    PUT_LINE(IMP,"    CALCUL DE L'INVERSE DE A");
    NEW_LINE(IMP);
    PUT_LINE("Attention: La decomposition L.R est possible si et seulement si");
    PUT_LINE("il n'y a pas de permutations dans la methode de GAUSS");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(0,DIM_MAX,n,"Dimension de la matrice: ");
    declare
	A, L, R, Inv: MATRICE(1..n,1..n);
	DET: FLOAT;
    begin
	DONNEE_MATRICE(A);
	DECOMPOSITION_LR(A,L,R);
	PUT_LINE(IMP,"    DECOMPOSITION L.R");
	PUT_LINE(IMP,"MATRICE L:");
	PUT_LINE(L);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"MATRICE R");
	PUT_LINE(R);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"    VERIFICATION: L*R = ");
	A := L*R;
	PUT_LINE(A);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"   CALCUL DU DETERMINANT");
	PUT("Det(A) = ");
	DET := DET_MATRICE_TRIANGULAIRE(R);
	FIO.PUT(DET,6,4,0);
	NEW_LINE;
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"   CALCUL DE L'INVERSE DE A");
	INV := INV_MATRICE_TRIANG_SUP(R)*INV_MATRICE_TRIANG_INF(L);
	PUT_LINE(INV);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"    VERIFICATION: A*INV(A) =");
	A := A*INV;
	PUT_LINE(A);
	PAUSE;
    end;
    CLOSE(IMP);
end DEM_LR;


