with TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
     DONNEES_ALGEBLIN;
use TEXT_IO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX, ALGEBLIN,
    DONNEES_ALGEBLIN;

procedure Dem_Piv is
n: NATURAL;

begin
    MODE_AFFICHAGE;
    PUT_LINE(IMP,"    RESOLUTION D'UN SYSTEME LINEAIRE");
    PUT_LINE(IMP,"       METHODE DES PIVOTS DE GAUSS");
    NEW_LINE(IMP);
    ENTRER_ENTIER_BORNE(0,DIM_MAX,n,"Dimension du systeme: ");
    declare
	A: MATRICE(1..n,1..n);
	b: VECTEUR(1..n);
    begin
	DONNEE_MATRICE(A);
	DONNEE_VECTEUR(b);
	PUT_LINE(IMP,"    SYSTEME AVANT PIVOTAGE");
	PUT_LINE(IMP,"MATRICE A:");
	PUT_LINE(A);
	PAUSE;
	PUT_LINE(IMP,"VECTEUR b");
	PUT_LINE(b);
	PAUSE;
	PIVOTAGE(A,b);
	CLRSCR;
	PUT_LINE(IMP,"    SYSTEME APRES PIVOTAGE");
	PUT_LINE(IMP,"MATRICE A:");
	PUT_LINE(A);
	PAUSE;
	PUT_LINE(IMP,"VECTEUR b");
	PUT_LINE(b);
	PAUSE;
	CLRSCR;
	PUT_LINE(IMP,"      SOLUTION DU SYSTEME");
	SYSTEME_TRIANGULAIRE_SUPERIEUR(A,b,b);
	PUT_LINE(b);
	CLOSE(IMP);
    end;
end DEM_PIV;


