with TEXT_IO, CRT, MATH0, MATRIX;
use TEXT_IO, CRT, MATH0, MATRIX;
package body DONNEES_ALGEBLIN is

procedure MENU_MATRICE(CHOIX_MATRICE: out POSITIVE) is
begin
    CLRSCR;
    NEW_LINE(5);
    PUT_LINE("    1: Matrice entree au clavier");
    PUT_LINE("    2: Matrice aleatoire");
    PUT_LINE("    3: Matrice entree depuis un fichier");
    PUT_LINE("    4: Matrice de Hilbert");
    PUT_LINE("    5: Matrice test symetrique definie par A(i,j) = n-j+1");
    PUT_LINE("    6: Matrice symetrique entree au clavier");
    PUT_LINE("    7: Matrice symetrique aleatoire");
    PUT_LINE("    8: Matrice symetrique entree depuis un fichier");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,8,CHOIX_MATRICE,"Votre choix: ");
    CLRSCR;
end MENU_MATRICE;
-- 
procedure DONNEE_MATRICE(A: in out MATRICE) is
CHOIX_MATRICE: POSITIVE range 1..8;
begin
   MENU_MATRICE(CHOIX_MATRICE);
   case CHOIX_MATRICE is
     when 1 =>
       PUT_LINE("Entree de la matrice du systeme");
       NEW_LINE;
       GET(A);
     when 2 =>
       MATRICE_ALEATOIRE(A);
     when 3 =>
       MATRICE_DU_FICHIER(A);
     when 4 =>
       MATRICE_HILBERT(A);
     when 5 =>
       MATRICE_TEST(A);
     when 6 =>
       PUT_LINE("Entree de la matrice symetrique du systeme");
       NEW_LINE;
       MATRICE_SYMETRIQUE(A);
     when 7 =>
       MATRICE_SYM_ALEATOIRE(A);
     when 8 =>
       MATRICE_SYM_DU_FICHIER(A);
   end case;
   CLRSCR;
end DONNEE_MATRICE;
-- 
procedure MENU_VECTEUR(CHOIX_VECTEUR: out POSITIVE) is
begin
    CLRSCR;
    NEW_LINE(5);
    PUT_LINE("    1: Vecteur entree au clavier");
    PUT_LINE("    2: Vecteur aleatoire");
    PUT_LINE("    3: Vecteur entree depuis un fichier");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,3,CHOIX_VECTEUR,"Votre choix: ");
    CLRSCR;
end MENU_VECTEUR;
-- 
procedure DONNEE_VECTEUR(b: in out VECTEUR) is
CHOIX_VECTEUR: POSITIVE range 1..3;
begin
   MENU_VECTEUR(CHOIX_VECTEUR);
   case CHOIX_VECTEUR is
    when 1 =>
      NEW_LINE;
      PUT_LINE("Entree du second membre");
      NEW_LINE;
      GET(b);
    when 2 =>
      VECTEUR_ALEATOIRE(b);
    when 3 =>
      VECTEUR_DU_FICHIER(b);
   end case;
   CLRSCR;
end DONNEE_VECTEUR;
-- 
procedure MENU_MATRICE_SYMETRIQUE(CHOIX_MATRICE: out POSITIVE) is
begin
    CLRSCR;
    NEW_LINE(5);
    PUT_LINE("    1: Matrice symetrique entree au clavier");
    PUT_LINE("    2: Matrice symetrique aleatoire");
    PUT_LINE("    3: Matrice symetrique entree depuis un fichier");
    PUT_LINE("    4: Matrice symetrique de Hilbert");
    PUT_LINE("    5: Matrice test symetrique definie par A(i,j) = n-j+1");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,5,CHOIX_MATRICE,"Votre choix: ");
    CLRSCR;
end MENU_MATRICE_SYMETRIQUE;
-- 
procedure DONNEE_MATRICE_SYMETRIQUE(A: in out MATRICE) is
CHOIX_MATRICE: POSITIVE range 1..5;
begin
   MENU_MATRICE_SYMETRIQUE(CHOIX_MATRICE);
   case CHOIX_MATRICE is
     when 1 =>
       PUT_LINE("Entree de la matrice symetrique du systeme");
       NEW_LINE;
       MATRICE_SYMETRIQUE(A);
     when 2 =>
       MATRICE_SYM_ALEATOIRE(A);
     when 3 =>
       MATRICE_SYM_DU_FICHIER(A);
     when 4 =>
       MATRICE_HILBERT(A);
     when 5 =>
       MATRICE_TEST(A);
   end case;
   CLRSCR;
end DONNEE_MATRICE_SYMETRIQUE;
-- 
procedure MENU_MATRICE_TRIDIAGONALE(CHOIX_MATRICE: out POSITIVE) is
begin
    CLRSCR;
    NEW_LINE(5);
    PUT_LINE("    1: Matrice tridiagonal entree au clavier");
    PUT_LINE("    2: Matrice tridiagonal aleatoire");
    PUT_LINE("    3: Matrice tridiagonal entree depuis un fichier");
    NEW_LINE;
    ENTRER_ENTIER_BORNE(1,3,CHOIX_MATRICE,"Votre choix: ");
    CLRSCR;
end MENU_MATRICE_TRIDIAGONALE;
-- 
procedure DONNEE_MATRICE_TRIDIAGONALE(A: in out MATRICE_TRIDIAGONALE) is
CHOIX_MATRICE: POSITIVE range 1..3;
begin
   MENU_MATRICE_TRIDIAGONALE(CHOIX_MATRICE);
   case CHOIX_MATRICE is
     when 1 =>
       PUT_LINE("Entree de la matrice tridiagonale du systeme");
       NEW_LINE;
       GET(A);
     when 2 =>
       MATRICE_TRIDIAG_ALEATOIRE(A);
     when 3 =>
       MATRICE_TRIDIAG_DU_FICHIER(A);
   end case;
   CLRSCR;
end DONNEE_MATRICE_TRIDIAGONALE;
-- 

end DONNEES_ALGEBLIN;





