with TEXT_IO, IIO, FIO, CRT, MATH0, MATH1;
use TEXT_IO, IIO, FIO, CRT, MATH0, MATH1;

package body DONNEES_POINTS is

procedure GET(x, y: in out VECTEUR; ORDRE: in BOOLEAN := FALSE) is
  begin
      TEXT_IO.PUT_LINE("Point Numero" & INTEGER'IMAGE(x'FIRST));
      ENTRER_REEL(x(x'FIRST),"         Abscisse: ");
      ENTRER_REEL(y(x'FIRST),"         Ordonnee: ");
      for i in x'FIRST + 1..x'LAST
      loop
	 TEXT_IO.PUT_LINE("Point Numero" & INTEGER'IMAGE(i));
	 if (ORDRE) then
	    loop
	      ENTRER_REEL(x(i),"         Abscisse: ");
	      exit when (x(i) > x(i - 1));
	      BIP;
     PUT_LINE("Erreur: les abscisses doivent etre croissantes, recommencer");
	    end loop;
	 else
	    ENTRER_REEL(x(i),"         Abscisse: ");
	 end if;
	 ENTRER_REEL(y(i),"         Ordonnee: ");
      end loop;
end GET;
-- 
procedure POINTS_DU_FICHIER(x, y: in out VECTEUR;
			    ORDRE: in BOOLEAN := FALSE;
			    NOM_DE_REPERTOIRE: in STRING := "A:\DONNEES") is
FICHIER: TEXT_IO.FILE_TYPE;
NOM_DE_FICHIER: STRING(1..50);
i: NATURAL;
begin
    x := (others => 0.0);
    y := (others => 0.0);
    LIRE_FICHIER(FICHIER,NOM_DE_FICHIER,NOM_DE_REPERTOIRE);
    i := x'FIRST;
    loop
       FIO.GET(FICHIER,x(i));
       FIO.GET(FICHIER,y(i));
       TEXT_IO.SKIP_LINE(FICHIER);
       i := i + 1;
       exit when (TEXT_IO.END_OF_FILE(FICHIER)) or (i > x'LAST);
    end loop;
    TEXT_IO.CLOSE(FICHIER);
    if (ORDRE) then
       for i in 2..x'LAST loop
	  if (x(i) <= x(i - 1)) then
	     PUT_LINE(
	       "POINTS_DU_FICHIER: les abscisses doivent etre croissantes");
	     raise CONSTRAINT_ERROR;
	  end if;
       end loop;
    end if;
end POINTS_DU_FICHIER;
-- 
procedure MENU_POINTS(CHOIX_POINTS: out POSITIVE) is
begin
    TEXT_IO.NEW_LINE;
    TEXT_IO.PUT_LINE("    1: Points entres au clavier");
    TEXT_IO.PUT_LINE("    2: Points aleatoires");
    TEXT_IO.PUT_LINE("    3: Points entres depuis un fichier");
    TEXT_IO.NEW_LINE;
    ENTRER_ENTIER_BORNE(1,3,CHOIX_POINTS,"Votre choix: ");
    CLRSCR;
end MENU_POINTS;
-- 
procedure ENTRER_POINTS(x, y: in out VECTEUR; ORDRE: in BOOLEAN := FALSE) is
CHOIX_POINTS: POSITIVE range 1..3;
begin
   MENU_POINTS(CHOIX_POINTS);
   case CHOIX_POINTS is
    when 1 =>
      TEXT_IO.NEW_LINE;
      TEXT_IO.PUT_LINE("Entree du nuage de points");
      TEXT_IO.NEW_LINE;
      GET(x,y,ORDRE);
    when 2 =>
      RANDOMIZE;
      if (ORDRE) then
	 for i in x'range loop
	    x(i) := FLOAT(i) + RANDOM;
	 end loop;
      else
	 for i in x'range loop
	    x(i) := -20.0 + 40.0*RANDOM;
	 end loop;
      end if;
      for i in y'range loop
	 y(i) := -20.0 + 40.0*RANDOM;
      end loop;
    when 3 =>
      POINTS_DU_FICHIER(x,y,ORDRE);
   end case;
   CLRSCR;
end ENTRER_POINTS;
-- 
procedure EXTREMA_POINTS(x, y: in VECTEUR;
			 xMin, xMax, yMin, yMax: in out FLOAT) is
begin
    xMin := 1.0E+37;
    yMin := xMin;
    xMax := -xMin;
    yMax := xMax;
    for i in x'range loop
       xMin := MIN(xMin,x(i));
       yMin := MIN(yMin,y(i));
       xMax := MAX(xMax,x(i));
       yMax := MAX(yMax,y(i));
    end loop;
end EXTREMA_POINTS;
-- 

end DONNEES_POINTS;

