--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                    SPECIFICATION DU PAQUETAGE GRAPH      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouve des procedures de base permettant de      
-- travailler en mode graphique.                                          
--ͼ

with COMMON_GRAPH;
use COMMON_GRAPH;

package GRAPH is

procedure CLEAR_SCREEN;
procedure CLOSE_GRAPH;
procedure INIT_GRAPH(CHOIX : CARTE_GRAPHIQUE);
PROCEDURE MOVE_TO(x: in INTEGER; y: in INTEGER);
procedure PUT_PIXEL(x: in INTEGER; y: in INTEGER);
procedure LINE(x, x1: in INTEGER; y, y1: in INTEGER);
PROCEDURE LINE_TO(x: in INTEGER; y: in INTEGER);
procedure RECTANGLE(x, x1: in INTEGER; y, y1: in INTEGER;
		    CLIP: in BOOLEAN := FALSE);

end GRAPH;

