with TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
     ALGEBLIN;
use TEXT_IO, IIO, FIO, CRT, COMMON_MATH0, MATH0, COMMON_MATRIX, MATRIX,
    ALGEBLIN;

procedure HILBERT is
D, u: FLOAT;
begin
    D := 1.0;
    u := 2.0;
    CLRSCR;
    TEXT_IO.PUT_LINE(IMP," n      DetFormule           DetCalcule");
    NEW_LINE(IMP);
    for n in 1..20 loop
    declare
       H: MATRICE(1..n + 1,1..n + 1);
    begin
       IIO.PUT(IMP,n + 1,4);
       D := D/(FLOAT(2*n + 1)*u*u);
       u := FLOAT(2*(2*n + 1))*u/FLOAT(n + 1);
       FIO.PUT(IMP,D);
       TEXT_IO.PUT(IMP,"   ");
       MATRICE_HILBERT(H);
       FIO.PUT(IMP,DETERMINANT_LR(H));
       TEXT_IO.NEW_LINE(IMP);
       exception
	 when PROGRAM_ERROR =>
	    PUT_LINE("Pivot trop petit");
    end;
    end loop;
    CLOSE(IMP);
    exception
       when STORAGE_ERROR =>
	  MESSAGE_ERREUR("HILBERT: Place memoire insuffisante");
end HILBERT;
