--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                       SPECIFICATION DU PAQUETAGE         
--                          INTEGRATION_GENERIQUE           
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage on trouvera des procedures de calculs d'integrales   
-- definies et de certaines integrales generiques.                        
--ͼ
with MATH2;
use MATH2;

generic
   with function f(x: in FLOAT) return FLOAT;
package INTEGRATION_GENERIQUE is
    function INTEGRATION_TRAPEZES(a, b: in FLOAT) return FLOAT;
    function INTEGRATION_SIMPSON(a, b: in FLOAT) return FLOAT;
    function INTEGRATION_ROMBERG(a,b: in FLOAT) return FLOAT;
    function INTEGRATION_LEGENDRE(a, b: in FLOAT) return FLOAT;
    function INTEGRATION_LAGUERRE return FLOAT;
    function INTEGRATION_HERMITE return FLOAT;
    function INTEGRATION_TCHEBYCHEV return FLOAT;

end INTEGRATION_GENERIQUE;
