--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE LAGRANGE      
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de realiser   
-- l'interpolation de Lagrange.                                           
--ͼ
with CURVE, COMMON_MATRIX;
use CURVE, COMMON_MATRIX;

package LAGRANGE is

function LAGRANGE_NEVILLE(x, y: VECTEUR; t: FLOAT) return FLOAT;
procedure POLYNOME_LAGRANGE(x, y: in VECTEUR; P: out VECTEUR);
function LAGRANGE_NEWTON(x, P: in VECTEUR; t: in FLOAT) return FLOAT;
procedure COURBE_INTERPOLATION_LAGRANGE(x,y: in VECTEUR; xMin, xMax: in FLOAT;
				 C: in out COURBE);

end LAGRANGE;

