--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE NIVEAUX       
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures permettant de tracer     
-- des courbes de niveaux f(x,y) = Cste.                                  
--ͼ
with MATH2, COMMON_MATRIX;
use MATH2, COMMON_MATRIX;

package NIVEAUX is

procedure DISCRETISE_FONCTION(f: in FONCTION;
			      xMin, xMax, yMin, yMax: in FLOAT;
			      M: in out MATRICE);
procedure TRACE_NIVEAU(XMin,XMax,YMin,YMax: in FLOAT; M: in MATRICE;
		       f: in FLOAT);
procedure TRACE_EQUIPOTENTIELLES(M: in MATRICE;
				 xMin, xMax, yMin, yMax: in FLOAT;
				 u0: in VECTEUR; AXES: in BOOLEAN := FALSE);
end NIVEAUX;
