--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--              SPECIFICATION DU PAQUETAGE EDP_PARABOLIQUES 
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage on trouvera des procedures de resolution de          
-- l'equation de la chaleur par differences finies.                       
--ͼ
with MATH2, COMMON_MATRIX;
use MATH2, COMMON_MATRIX;

package EDP_PARABOLIQUES is

NX_MAX: CONSTANT := 200;
NT_MAX: constant := 30;

procedure EDP_CHALEUR_EXPLICITE(k, dx, dt: in FLOAT; f: in FONCTION;
				U: in out MATRICE);
procedure EDP_CHALEUR_IMPLICITE(w, k, dx, dt: in FLOAT; f: in FONCTION;
				U: in out MATRICE);
procedure AFFICHER_TEMPERATURES(U: in MATRICE; dt: in FLOAT; p: in INTEGER);
procedure COURBES_CHALEUR(U: in MATRICE; dx: in FLOAT; p: in INTEGER);

end EDP_PARABOLIQUES;
