--                 ͻ
--                      RECHERCHE DE NOMBRES PREMIERS    
--                          CRIBLE D'ERATOSTHENE         
--                 ͼ

with TEXT_IO, IIO, LIO, CRT, COMMON_MATH0, MATH0;
use TEXT_IO, IIO, LIO, CRT, COMMON_MATH0, MATH0;

procedure PREMIERS is

type TABLEAU_BOOLEENS is array(LONG_INTEGER range <>) of BOOLEAN;
nMax: constant LONG_INTEGER := 60_000;
n: LONG_INTEGER;

procedure MENU_PREMIER(n: out LONG_INTEGER) is
begin
    CLRSCR;
    PUT_LINE("RECHERCHE DE NOMBRES PREMIERS");
    NEW_LINE;
    ENTRER_ENTIER_LONG_BORNE(2,nMax,n,
			"Borne superieure de recherche (m > 2): ");
    CLRSCR;
end MENU_PREMIER;

procedure CALCUL_PREMIERS(n: in LONG_INTEGER) is
k, m, COMPTEUR: LONG_INTEGER;
C: TABLEAU_BOOLEENS(1..n);
begin
    CHRONOMETRE(0);
    k := 2; m := k;
    COMPTEUR := 0;
    C := (others => TRUE);
    C(1) := FALSE;
    while (k < n) loop
      if c(k) then
	if ( (COMPTEUR mod 9) = 0) then
	  PUT_LINE(IMP," ");
	end if;
	COMPTEUR := COMPTEUR + 1;
	PUT(IMP,k,8);
	m := k;
	while (m  < n - k) loop
	 begin
	  m := m + k;
	  c(m) := FALSE;
	 end;
	end loop;
      end if;
      k := k + 1;
    end loop;
    PUT_LINE(IMP," ");
    PUT_LINE(IMP," ");
    CHRONOMETRE(1);
    PUT(IMP,"Nombre d'entiers premiers: ");
    PUT(IMP,COMPTEUR);
    PUT_LINE(IMP," ");
end CALCUL_PREMIERS;

begin
    MODE_AFFICHAGE;
    MENU_PREMIER(n);
    CALCUL_PREMIERS(n);
    CLOSE(IMP);
end PREMIERS;

