--             ͻ
--                             J. E. ROMBALDI               
--                      E.N.S.A.M. CHALONS SUR MARNE        
--                           COPYRIGHT (C) 1993             
--                 SPECIFICATION DU PAQUETAGE REGRESSIONS   
--             ͼ

--ͻ
--                        Utilite du paquetage.                           
--                                                                        
-- Dans ce paquetage, on trouvera des procedures de calcul d'une droite,  
-- d'un polynome ou d'un cercle des moindres carres.                      
--ͼ

with COMMON_MATRIX, COMMON_POLY;
use COMMON_MATRIX, COMMON_POLY;

package REGRESSIONS is

procedure REGRESSION_AFFINE(x, y: in VECTEUR; a, b, Rho: in out FLOAT);
procedure REGRESSION_POLYNOMIALE(x, y: in VECTEUR; U: out POLYNOME);
procedure REGRESSION_CIRCULAIRE(x, y: in VECTEUR; a, b, r: in out FLOAT);

end REGRESSIONS;
